// i2c_eep.h	By KCO
#ifndef __I2CEEP_H
#define	__I2CEEP_H
#include "common.h"

#define sEE_I2C                 I2C2
#define sEE_I2C_CLK             RCC_APB1Periph_I2C2
#define sEE_I2C_SCL_PIN         GPIO_Pin_10             /* PB.10 */
#define sEE_I2C_SCL_GPIO_PORT   GPIOB                   /* GPIOB */
#define sEE_I2C_SCL_GPIO_CLK    RCC_APB2Periph_GPIOB
#define sEE_I2C_SDA_PIN         GPIO_Pin_11             /* PB.11 */
#define sEE_I2C_SDA_GPIO_PORT   GPIOB                   /* GPIOB */
#define sEE_I2C_SDA_GPIO_CLK    RCC_APB2Periph_GPIOB

#define AT24Cxx_ADDR            0xA0
#define EEPROM_DATA_SIZE        256

#define EEP_MAX_CNT             10000
#define I2C_EEP_SPEED           200000

/* Type declarations ---------------------------------------------------------*/
typedef enum{
    AT24C01, AT24C02, AT24C04, AT24C06, AT24C08,AT24C16,
    AT24C32, AT24C64, AT24C128, AT24C256, AT24C512, AT24C1024
}EEP_TYPE;

typedef enum{
    EEPROM_SUCCESS,
    EEPROM_ERROR
}EEPROM_Status;

typedef struct{
    int DeviceType;
    u8  DeviceAddress;
    u32 InterAddress;
    int DataLength;
    u8 Data[EEPROM_DATA_SIZE];
}EEPROM_Info;

/* Function prototypes -------------------------------------------------------*/
EEPROM_Status i2c_eep_write(EEPROM_Info *eeprom);
EEPROM_Status i2c_eep_read(EEPROM_Info *eeprom);
void init_i2c_eep(int dev_type);
void i2c_eep_sw_reset(void);

#endif
