// KCO 2010.5.31
#include <intrinsics.h>
#include "stm32f10x.h"
#include "common.h"
#include "lcd.h"
#include "key.h"
#include "can.h"

extern CanTxMsg TxMessage;
extern CanRxMsg RxMessage;
extern u8 can_rx_flag,can_rx_cnt;

int mcnt=0;
u8 can_txd1[8],can_txd2[8];

void	key_down_proc(BYTE c){
	switch(c){
		case 0: 
            can_txd2[0]=0x00;
            can_txd2[1]=0x11;
            can_txd2[2]=0x22;
            can_txd2[3]=0x33;
            can_txd2[4]=0x44;
            can_txd2[5]=0x55;
            can_txd2[6]=0x66;
            can_txd2[7]=0x77;
            can_tx_data_s(0x000, can_txd2); // send std. type
            lcd_gotoxy(0,2);    lcd_puts("CAN2.0A(Std)ID=0x000");
            lcd_gotoxy(0,3);    lcd_puts("Txd:0011223344556677");
 			break;
		case 1:
            can_txd2[0]=0x00;
            can_txd2[1]=0x11;
            can_txd2[2]=0x22;
            can_txd2[3]=0x33;
            can_txd2[4]=0x44;
            can_txd2[5]=0x55;
            can_txd2[6]=0x66;
            can_txd2[7]=0x77;
            can_tx_data_e(0x12345678, can_txd2); // send ext. type
            lcd_gotoxy(0,2);    lcd_puts("CAN2.0B,ID=0x1234567");
            lcd_gotoxy(0,3);    lcd_puts("Txd:0011223344556677");
           break;
		case 2:
            can_txd2[0]=0x01;
            can_txd2[1]=0x23;
            can_txd2[2]=0x45;
            can_txd2[3]=0x67;
            can_txd2[4]=0x89;
            can_txd2[5]=0xab;
            can_txd2[6]=0xcd;
            can_txd2[7]=0xef;
            can_tx_data_e(0x11223344, can_txd2); // send ext. type
            lcd_gotoxy(0,2);    lcd_puts("CAN2.0B,ID=0x11223344");
            lcd_gotoxy(0,3);    lcd_puts("Txd:0123456789abcdef");
			break;
		case 3:
            can_txd2[0]=0x01;
            can_txd2[1]=0x23;
            can_txd2[2]=0x45;
            can_txd2[3]=0x67;
            can_txd2[4]=0x89;
            can_txd2[5]=0xab;
            can_txd2[6]=0xcd;
            can_txd2[7]=0xef;
            can_tx_data_s(0x7ff, can_txd2); // send std. type

            lcd_gotoxy(0,2);    lcd_puts("CAN2.0A(Std)ID=0x7ff");
            lcd_gotoxy(0,3);    lcd_puts("Txd:0123456789abcdef");
			break;
		case 4:
            lcd_gotoxy(0,2);
            lcd_puts("                    ");
            lcd_gotoxy(0,3);
            lcd_puts("                    ");
            clear_can_rx_message(&RxMessage);
 			break;
		default:	
			break;
	}
}

void	key_up_proc(BYTE c){
	switch(c){
		case 0:
			break;
		case 1:
			break;
		case 2:
			break;
		case 3:
			break;
		case 4:
			break;
		default:	
			break;
	}
}
BYTE	key_cnt=0;
void	key_cont_proc(BYTE c){
	switch(c){
		case 0:
          key_down_proc(c);
			break;
		case 1:
          key_down_proc(c);
			break;
		case 2:
          key_down_proc(c);
			break;
		case 3:
          key_down_proc(c);
			break;
		case 4:
			break;
		default:	
			break;
	}
}

WORD	key_code;
void	key_process(void){
WORD	i,c;
	key_code = key5_proc();
	for(i=0;i<5;i++){
	  	c = (key_code>>(2*i) )& 0x03;
		if(c == KEY_CONT) key_cont_proc(i);
		else if(c == KEY_DOWN) key_down_proc(i);
		else if(c == KEY_UP) key_up_proc(i);
	}
}

void TIM1_UP_IRQHandler(void){  // Timer1 interrupt routine
    // Clear update interrupt bit
    TIM_ClearITPendingBit(TIM1,TIM_FLAG_Update);
    check_period_flag();
}
u32 tx_cnt=0;
void main(void){
GPIO_InitTypeDef GPIO_InitStructure;
NVIC_InitTypeDef NVIC_InitStructure;
TIM_TimeBaseInitTypeDef TIM1_TimeBaseInitStruct;

    /* Setup STM32 system (clock, PLL and Flash configuration) */
    SystemInit();
    
    /* Set the Vector Table base location at 0x08000000 */
    NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_4);
    
    //*********************** GPIO Init *****************************
    // Enable GPIO clock and release reset
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA |
                         RCC_APB2Periph_GPIOB |
                         RCC_APB2Periph_GPIOC,
                         ENABLE);
    RCC_APB2PeriphResetCmd(RCC_APB2Periph_GPIOA |
                         RCC_APB2Periph_GPIOB |
                         RCC_APB2Periph_GPIOC,
                         DISABLE);
    
    // Assign PC8, PC9 to LEDs
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9;
    GPIO_Init(GPIOC, &GPIO_InitStructure);
    
    //************************ Timer1 Init **************************
    // Enable Timer1 clock and release reset
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1,ENABLE);
    RCC_APB2PeriphResetCmd(RCC_APB2Periph_TIM1,DISABLE);
    // Set timer period 100 usec
    TIM1_TimeBaseInitStruct.TIM_Prescaler = 72;  // 1us resolution
    TIM1_TimeBaseInitStruct.TIM_CounterMode = TIM_CounterMode_Up;
    TIM1_TimeBaseInitStruct.TIM_Period = 100;  // 100 us
    TIM1_TimeBaseInitStruct.TIM_ClockDivision = TIM_CKD_DIV1;
    TIM1_TimeBaseInitStruct.TIM_RepetitionCounter = 0;
    TIM_TimeBaseInit(TIM1,&TIM1_TimeBaseInitStruct);
    // Clear update interrupt bit
    TIM_ClearITPendingBit(TIM1,TIM_FLAG_Update);
    // Enable update interrupt
    TIM_ITConfig(TIM1,TIM_FLAG_Update,ENABLE);
    
    NVIC_InitStructure.NVIC_IRQChannel = TIM1_UP_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 7;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
    // Enable timer counting
    TIM_Cmd(TIM1,ENABLE);

	lcd_init(20,4);
    init_key();
    init_can();
    
    __enable_interrupt();

	lcd_gotoxy(0,0);
	lcd_puts("*** CAN Test ***");
    
     
    while(1){
        if(can_rx_flag){
          can_rx_flag = 0;
          lcd_gotoxy(0,2);
          lcd_printf("Rx_cnt=%02X",can_rx_cnt);
          if(RxMessage.IDE==CAN_ID_STD){
            lcd_printf(",S:%03X     ",RxMessage.StdId);
          }
          else{
            lcd_printf(",E:%08X",RxMessage.ExtId);
          }
          lcd_gotoxy(0,3);
          lcd_printf("%d: %02X%02X%02X%02X %02X%02X%02X%02X",RxMessage.DLC,
                     RxMessage.Data[0],RxMessage.Data[1],RxMessage.Data[2],RxMessage.Data[3],
                     RxMessage.Data[4],RxMessage.Data[5],RxMessage.Data[6],RxMessage.Data[7]);
        }
	    if(flag_1ms){
	    	flag_1ms = 0;
	    }
	    if(flag_2ms){
	    	flag_2ms = 0;
	    }
	    if(flag_10ms){
	    	flag_10ms = 0;
			key_process();
		}
	    if(flag_100ms){
	    	flag_100ms = 0;
            mcnt++;
            lcd_gotoxy(0,1);
            lcd_printf("mcnt=%04X(%5d)",mcnt,mcnt);
		}
	    if(flag_300ms){
	    	flag_300ms = 0;
		}
    }
}
